// playDlg.cpp : t@C
//

#include "stdafx.h"
#include "play.h"
#include "playDlg.h"

#include <locale.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CplayDlg _CAO

#define PLAY_INI_FILE	_T(".\\play.ini")
#define CAPSTS_INI_FILE	_T(".\\cap_sts_sea.ini")

BOOL no_prompt;


CplayDlg::CplayDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CplayDlg::IDD, pParent)
	, m_filename(_T(""))
	, m_vlcparam(_T(""))
	, m_time(_T(""))
	, m_no_prompt(FALSE)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CplayDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST1, m_ChList);
	DDX_Text(pDX, IDC_EDIT1, m_filename);
	DDX_Text(pDX, IDC_EDIT2, m_vlcparam);
	DDX_Text(pDX, IDC_EDIT3, m_time);
	DDX_Control(pDX, IDC_BUTTON1, m_view_button);
	DDX_Check(pDX, IDC_CHECK1, m_no_prompt);
}

BEGIN_MESSAGE_MAP(CplayDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_LBN_SELCHANGE(IDC_LIST1, &CplayDlg::OnLbnSelchangeList1)
	ON_BN_CLICKED(IDC_BUTTON1, &CplayDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CplayDlg::OnBnClickedButton2)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_BUTTON3, &CplayDlg::OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON5, &CplayDlg::OnBnClickedButton5)
	ON_BN_CLICKED(IDC_BUTTON4, &CplayDlg::OnBnClickedButton4)
	ON_LBN_DBLCLK(IDC_LIST1, &CplayDlg::OnLbnDblclkList1)
END_MESSAGE_MAP()


// CplayDlg bZ[W nh

BOOL CplayDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	// TODO: ɒǉ܂B

	m_hThread = NULL;
	m_sel_ch = -1;

	LoadChannelFile();


	wchar_t buff[1024];
	GetPrivateProfileString(L"PLAY_SETTING",L"VLC_PARAM",L"",buff,sizeof(buff),PLAY_INI_FILE);
	m_vlcparam = buff;
	GetPrivateProfileString(L"PLAY_SETTING",L"TIME",L"30",buff,sizeof(buff),PLAY_INI_FILE);
	m_time = buff;
	GetPrivateProfileString(L"PLAY_SETTING",L"FILENAME",L"test.ts2",buff,sizeof(buff),PLAY_INI_FILE);
	m_filename = buff;

	m_no_prompt = GetPrivateProfileInt(L"PLAY_SETTING",L"NO_PROMPT",0,PLAY_INI_FILE) ? true : false;
	no_prompt = m_no_prompt;
	UpdateData(FALSE);


	PowerOn();

    CWinApp*  pApp = AfxGetApp();
    CRect  rcWindow;
    rcWindow.left   = GetPrivateProfileInt( L"PLAY_SETTING", L"left", 0 ,PLAY_INI_FILE);
    rcWindow.top   = GetPrivateProfileInt( L"PLAY_SETTING", L"top", 0 ,PLAY_INI_FILE);
    rcWindow.right   = GetPrivateProfileInt( L"PLAY_SETTING", L"right", 230 ,PLAY_INI_FILE);
    rcWindow.bottom   = GetPrivateProfileInt( L"PLAY_SETTING", L"bottom", 230 ,PLAY_INI_FILE);
    //  EBhEʒuC
    MoveWindow( rcWindow );

	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CplayDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// [U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CplayDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CplayDlg::OnLbnSelchangeList1()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	m_sel_ch = m_ChList.GetCurSel();
}

void CplayDlg::LoadChannelFile(void)
{
	FILE	*fp;
	wchar_t buffer[WCHAR_MAX];

	_wsetlocale(LC_CTYPE, L"Japanese");					//P[VZbg

	channel_number = 0;
	memset(channel, '\0', sizeof(channel));

	wchar_t file[256];
	wchar_t *lastbackslash;
	GetModuleFileNameW(NULL,file,256);
	lastbackslash = wcsrchr(file, '\\');
	wcscpy_s(lastbackslash, 256 - (lastbackslash - &file[0]), L"\\channel.txt");

	_wfopen_s(&fp, file, L"r+t");	//ǂݍݐpAeLXg[h
	if(fp == NULL){
		return;
	}

	m_ChList.ResetContent();

	while(true){
		wchar_t *f, *n;
		if(fgetws(buffer, WCHAR_MAX, fp) == NULL) break;

		f = wcschr(&buffer[0], ',');
		wcsncpy_s(channel[channel_number].name, 32, &buffer[0], f - &buffer[0]);
		m_ChList.InsertString(channel_number,channel[channel_number].name);
		f++;
		n = wcschr(f, ',');
		wcsncpy_s(channel[channel_number].command, 10, f, n - f);
		n++;
		wcscpy_s(channel[channel_number].IdentificationWord, 128, n);
		channel_number++;
	}
	fclose(fp);
}


DWORD WINAPI func(LPVOID lpArg) 
{

	PROCESS_INFORMATION pi;
	STARTUPINFO si;

	ZeroMemory(&si,sizeof(si));
	si.cb=sizeof(si);

	CreateProcess(NULL,(LPTSTR)lpArg,NULL,NULL,FALSE,no_prompt ? DETACHED_PROCESS : 0,
		NULL,NULL,&si,&pi);

	CloseHandle(pi.hThread);

	WaitForSingleObject(pi.hProcess,INFINITE);

	CloseHandle(pi.hProcess);

	ExitThread(0);

	return 0;

}


bool CplayDlg::OpenCommandBlock(LPTSTR vlc)
{
	STARTUPINFO si;
	PROCESS_INFORMATION pi;

	// VLC̋NB
	::ZeroMemory(&si, sizeof(STARTUPINFO));
	si.cb           = sizeof(STARTUPINFO);
	si.dwFlags      = STARTF_USESHOWWINDOW;
	si.wShowWindow  = SW_SHOWNORMAL;
	CreateProcess(NULL, vlc, NULL, NULL, TRUE, m_no_prompt ? DETACHED_PROCESS : 0, NULL, NULL, &si, &pi);

	CloseHandle(pi.hThread);

	WaitForSingleObject(pi.hProcess,INFINITE);

	CloseHandle(pi.hProcess);

	return TRUE;
}


bool CplayDlg::OpenCommandNoBlock(LPTSTR vlc)
{
	DWORD dwThreadId;
	
	m_hThread = CreateThread(NULL,0,func,vlc,0,&dwThreadId); 

	return TRUE;
}



void CplayDlg::OnBnClickedButton1()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	wchar_t buffer[WCHAR_MAX];
	CString str;
	UpdateData(TRUE);
	no_prompt = m_no_prompt;

	if(m_hThread){
//		wcscpy_s(buffer,WCHAR_MAX,L"cap_sts.exe stop");
//		OpenCommandBlock(buffer);
//		WaitForSingleObject(m_hThread,3000);
//		m_hThread = 0;
		str = "cap_sts.exe ch:@";
		str += channel[m_sel_ch].command;
	} else {

		if(m_sel_ch != -1){
			str = "cap_sts.exe view 120 @";
			str += channel[m_sel_ch].command;
		} else {
			str = "cap_sts.exe view 120 B";
		}
	}
	m_view_button.SetWindowTextW((LPCTSTR)L"ch؂ւ");

	wcscpy_s(buffer,WCHAR_MAX,str);

	OpenCommandNoBlock(buffer);
}

void CplayDlg::OnBnClickedButton2()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B

	wchar_t buffer[WCHAR_MAX];
	UpdateData(TRUE);
	no_prompt = m_no_prompt;


	if(m_hThread){
		wcscpy_s(buffer,WCHAR_MAX,L"cap_sts.exe stop");
		OpenCommandBlock(buffer);
		WaitForSingleObject(m_hThread,3000);
		m_hThread = 0;
		m_view_button.SetWindowTextW((LPCTSTR)L"");

	}
}

void CplayDlg::PowerOn()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B

	wchar_t buffer[WCHAR_MAX];

	if(m_hThread == 0){
		wcscpy_s(buffer,WCHAR_MAX,L"cap_sts.exe stop fpon");
		OpenCommandBlock(buffer);
		WaitForSingleObject(m_hThread,3000);
	}
}

void CplayDlg::PowerOff()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B

	wchar_t buffer[WCHAR_MAX];

	wcscpy_s(buffer,WCHAR_MAX,L"cap_sts.exe stop fpoff");
	OpenCommandBlock(buffer);
	WaitForSingleObject(m_hThread,3000);
}

void CplayDlg::OnClose()
{
	// TODO: ɃbZ[W nh R[hǉ邩ȀĂяo܂B
	PowerOff();

	UpdateData(TRUE);
	no_prompt = m_no_prompt;

	WritePrivateProfileString(L"PLAY_SETTING",L"VLC_PARAM",m_vlcparam,PLAY_INI_FILE);
	WritePrivateProfileString(L"PLAY_SETTING",L"TIME",m_time,PLAY_INI_FILE);
	WritePrivateProfileString(L"PLAY_SETTING",L"FILENAME",m_filename,PLAY_INI_FILE);
	WritePrivateProfileString(L"PLAY_SETTING",L"NO_PROMPT",m_no_prompt ? L"1" : L"0" ,PLAY_INI_FILE);
    WINDOWPLACEMENT  wndpl;
    //  EBhEʒu擾
    GetWindowPlacement( &wndpl );
    //  WXgɕۑ
    CWinApp*  pApp = AfxGetApp();
	wchar_t buffer[WCHAR_MAX];
	wsprintf(buffer,L"%d",wndpl.rcNormalPosition.left);
    WritePrivateProfileString( L"PLAY_SETTING", L"left",   buffer ,PLAY_INI_FILE);
	wsprintf(buffer,L"%d",wndpl.rcNormalPosition.top);
    WritePrivateProfileString( L"PLAY_SETTING", L"top",   buffer ,PLAY_INI_FILE);
	wsprintf(buffer,L"%d",wndpl.rcNormalPosition.right);
    WritePrivateProfileString( L"PLAY_SETTING", L"right",   buffer ,PLAY_INI_FILE);
	wsprintf(buffer,L"%d",wndpl.rcNormalPosition.bottom);
    WritePrivateProfileString( L"PLAY_SETTING", L"bottom",   buffer ,PLAY_INI_FILE);

	CDialog::OnClose();
}

BOOL FileExist(
LPCTSTR lpszFileName)
{
	return GetFileAttributes(lpszFileName) != 0xFFFFFFFF;
}

void CplayDlg::OnBnClickedButton3()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B

	// ^
	wchar_t buffer[WCHAR_MAX];

	UpdateData(TRUE);
	no_prompt = m_no_prompt;

	if(FileExist(m_filename)){
		if(MessageBox(L"t@C݂܂B㏑܂H",L"mF",MB_OKCANCEL|MB_ICONQUESTION|MB_TOPMOST) != IDOK){
			return;
		}
	}

	if(m_hThread){
		wcscpy_s(buffer,WCHAR_MAX,L"cap_sts.exe stop");
		OpenCommandBlock(buffer);
		WaitForSingleObject(m_hThread,3000);
		m_hThread = 0;
		m_view_button.SetWindowTextW((LPCTSTR)L"");
	}
	CString str;

	if(m_sel_ch != -1){
		str = "cap_sts.exe B fn @";
		str += channel[m_sel_ch].command;
	} else {
		str = "cap_sts.exe fn B";
	}
	if(m_time != ""){
		str += " ";
		str += m_time;
	} else {
		str += " 30";
	}
	if(m_vlcparam != ""){
		str += " vlc:";
		str += m_vlcparam;
	}
	if(m_filename != ""){
		str += " ";
		str += m_filename;
	} else {
		str += " test.ts2";
	}

	wcscpy_s(buffer,WCHAR_MAX,str);

	OpenCommandNoBlock(buffer);
}

void CplayDlg::OnBnClickedButton5()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	// Add{^
	CString str;
	wchar_t buffer[WCHAR_MAX];

	str = "cap_sts.exe ADD";

	if(m_time != ""){
		str += " ";
		str += m_time;
	} else {
		str += " 30";
	}

	wcscpy_s(buffer,WCHAR_MAX,str);

	OpenCommandNoBlock(buffer);
}

void CplayDlg::OnBnClickedButton4()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	// ǂĐ{^
	
	wchar_t buff[256];

	GetPrivateProfileString(L"VLC_SETTING",L"VLC_PATH",L"C:\\Program Files\\VideoLAN\\VLC\\vlc.exe",buff,sizeof(buff),CAPSTS_INI_FILE);
	CString str;

	ShellExecute(NULL,NULL,buff,m_filename,NULL,SW_SHOWNORMAL);
}

void CplayDlg::OnLbnDblclkList1()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	OnBnClickedButton1();
}
